#include <Wire.h>
#include <Adafruit_PWMServoDriver.h>

Adafruit_PWMServoDriver board1 = Adafruit_PWMServoDriver(0x40);
Adafruit_PWMServoDriver board2 = Adafruit_PWMServoDriver(0x41);
Adafruit_PWMServoDriver board3 = Adafruit_PWMServoDriver(0x42);

#define SERVOMIN  544 // This is the 'minimum' pulse length count (out of 4096)
#define SERVOMAX  2400// This is the 'maximum' pulse length count (out of 4096)
//#define USMIN  600 // This is the rounded 'minimum' microsecond length based on the minimum pulse of 150
//#define USMAX  2400 // This is the rounded 'maximum' microsecond length based on the maximum pulse of 600
#define SERVO_FREQ 50 // Analog servos run at ~50 Hz updates

int number; // number command 

///////////////////////////////////////////////////////////////////////////////////

void setup() {  // put your setup code here, to run once:

Serial.begin(9600); // initialize Serial connection

board1.begin();  // Initialize servo ccontrol boards 
board2.begin();
board3.begin();
board1.setOscillatorFrequency(27000000);
board2.setOscillatorFrequency(27000000);
board3.setOscillatorFrequency(27000000);
board1.setPWMFreq(SERVO_FREQ);  // Analog servos run at ~50 Hz updates
board2.setPWMFreq(SERVO_FREQ); 
board3.setPWMFreq(SERVO_FREQ); 

Serial.println("Ready for command");

yield();
}

///////////////////////////////////////////////////////////////////////////////////

void loop() {  // put your main code here, to run repeatedly:

while(Serial.available()>0){ //see if a command has been sent
  number = Serial.parseInt(); //turn command into integer
  Serial.print(number);
  Serial.println(" sent");
  digit4(number);
}
delay(1000);
}

///////////////////////////////////////////////////////////////////////////////////

int angleToPulse(int ang){
   int pulse1 = map(ang,0, 180, SERVOMIN,SERVOMAX); // map angle of 0 to 180 to Servo min and Servo max 
   int pulse2 = int(float(pulse1) / 1000000 * SERVO_FREQ * 4096);
   Serial.print("Angle: ");Serial.print(ang);
   Serial.print(" pulse: ");Serial.println(pulse2);
   return pulse2;
}

///////////////////////////////////////////////////////////////////////////////////
void digit4(int number){
if (number == 99) {
board3.setPWM(6, 0, angleToPulse(39));delay(200);
board3.setPWM(5, 0, angleToPulse(101));delay(200);
}
else if (number == 1) {
board3.setPWM(11, 0, angleToPulse(40));delay(200);
board3.setPWM(9, 0, angleToPulse(23));delay(200);
board3.setPWM(8, 0, angleToPulse(17));delay(200);
board3.setPWM(7, 0, angleToPulse(33));delay(200);
board3.setPWM(6, 0, angleToPulse(24));delay(200);
board3.setPWM(5, 0, angleToPulse(18));delay(200);
board3.setPWM(4, 0, angleToPulse(18));delay(200);
board3.setPWM(14, 0, angleToPulse(42));delay(200);
board3.setPWM(10, 0, angleToPulse(102));delay(200);
board3.setPWM(11, 0, angleToPulse(101));delay(200);
}
else if (number == 2) {
board3.setPWM(9, 0, angleToPulse(75));delay(200);
board3.setPWM(8, 0, angleToPulse(65));delay(200);
board3.setPWM(7, 0, angleToPulse(88));delay(200);
board3.setPWM(6, 0, angleToPulse(40));delay(200);
board3.setPWM(5, 0, angleToPulse(100));delay(200);
board3.setPWM(4, 0, angleToPulse(66));delay(200);
board3.setPWM(14, 0, angleToPulse(7));delay(200);
board3.setPWM(12, 0, angleToPulse(20));delay(200);
board3.setPWM(11, 0, angleToPulse(4));delay(200);
board3.setPWM(10, 0, angleToPulse(8));delay(200);
}
else if (number == 3) {
board3.setPWM(6, 0, angleToPulse(75));delay(200);
board3.setPWM(5, 0, angleToPulse(61));delay(200);
board3.setPWM(11, 0, angleToPulse(103));delay(200);
}
else if (number == 4) {
board3.setPWM(11, 0, angleToPulse(40));delay(200);
board3.setPWM(9, 0, angleToPulse(40));delay(200);
board3.setPWM(8, 0, angleToPulse(32));delay(200);
board3.setPWM(7, 0, angleToPulse(119));delay(200);
board3.setPWM(5, 0, angleToPulse(18));delay(200);
board3.setPWM(4, 0, angleToPulse(18));delay(200);
board3.setPWM(14, 0, angleToPulse(42));delay(200);
board3.setPWM(12, 0, angleToPulse(50));delay(200);
board3.setPWM(10, 0, angleToPulse(102));delay(200);
board3.setPWM(11, 0, angleToPulse(101));delay(200);
}
else if (number == 5) {
board3.setPWM(9, 0, angleToPulse(76));delay(200);
board3.setPWM(5, 0, angleToPulse(65));delay(200);
board3.setPWM(4, 0, angleToPulse(66));delay(200);
board3.setPWM(15, 0, angleToPulse(10));delay(200);
board3.setPWM(14, 0, angleToPulse(8));delay(200);
board3.setPWM(13, 0, angleToPulse(50));delay(200);
board3.setPWM(12, 0, angleToPulse(18));delay(200);
board3.setPWM(10, 0, angleToPulse(7));delay(200);
}
else if (number == 6) {
board3.setPWM(6, 0, angleToPulse(40));delay(200);
board3.setPWM(5, 0, angleToPulse(100));delay(200);
}
else if (number == 7) {
board3.setPWM(11, 0, angleToPulse(40));delay(200);
board3.setPWM(8, 0, angleToPulse(65));delay(200);
board3.setPWM(7, 0, angleToPulse(33));delay(200);
board3.setPWM(6, 0, angleToPulse(23));delay(200);
board3.setPWM(5, 0, angleToPulse(18));delay(200);
board3.setPWM(4, 0, angleToPulse(18));delay(200);
board3.setPWM(15, 0, angleToPulse(48));delay(200);
board3.setPWM(13, 0, angleToPulse(119));delay(200);
board3.setPWM(12, 0, angleToPulse(50));delay(200);
board3.setPWM(10, 0, angleToPulse(102));delay(200);
board3.setPWM(11, 0, angleToPulse(101));delay(200);
}
else if (number == 8) {
board3.setPWM(8, 0, angleToPulse(32));delay(200);
board3.setPWM(7, 0, angleToPulse(118));delay(200);
board3.setPWM(6, 0, angleToPulse(75));delay(200);
board3.setPWM(5, 0, angleToPulse(100));delay(200);
board3.setPWM(4, 0, angleToPulse(66));delay(200);
board3.setPWM(12, 0, angleToPulse(20));delay(200);
board3.setPWM(10, 0, angleToPulse(7));delay(200);
}
else if (number == 9) {
board3.setPWM(6, 0, angleToPulse(76));delay(200);
board3.setPWM(5, 0, angleToPulse(61));delay(200);
board3.setPWM(12, 0, angleToPulse(48));delay(200);
}
}
